/*
Module : APIPE.H
Purpose: Defines the interface for an MFC wrapper classe
         for Win32 Anonymous Pipes
Created: PJN / 2-08-1998
History: None

Copyright (c) 1998 by PJ Naughter.  
All rights reserved.

*/

#ifndef __APIPE_H__
#define __APIPE_H__


//Wrapper class to encapsulate an anonymous pipe

class CAnonymousPipe : public CObject
{
public:
//Constructors / Destructors
  CAnonymousPipe();
  ~CAnonymousPipe();

//Creation & Opening
  BOOL Create(LPSECURITY_ATTRIBUTES lpPipeAttributes = NULL, DWORD dwSize = 0);

//General functions
  BOOL Write(LPCVOID lpBuffer, DWORD dwNumberOfBytesToWrite, DWORD& dwNumberOfBytesWritten);	
  BOOL Read(LPVOID lpBuffer, DWORD dwNumberOfBytesToRead, DWORD& dwNumberOfBytesRead);
  BOOL Peek(LPVOID lpBuffer, DWORD dwBufferSize, DWORD& dwBytesRead, 
            DWORD& dwTotalBytesAvail, DWORD& dwBytesLeftThisMessage);
  BOOL Close();

//State accessors
  BOOL IsOpen() const { return (m_hWrite != INVALID_HANDLE_VALUE); };

//Diagnostics / Debug support
#ifdef _DEBUG
  virtual void AssertValid() const;
  virtual void Dump(CDumpContext& dc) const;
#endif

protected:
  DECLARE_DYNAMIC(CAnonymousPipe)

  HANDLE m_hWrite;
  HANDLE m_hRead;
};


#endif //__APIPE_H__